# (ngompa): Don't erase RPATHs for internal libs
%define _cmake_skip_rpath %nil

# Release value outside of snapshot ver
%define rel 2

# Don't ship updater applet, since it is broken
%bcond_with applet

# Snapshot date
%global snap 20161109

Name:		apper
Summary:	KDE interface for PackageKit
Group:		System/Packaging
License:	GPLv2+
Version:	0.9.3
Release:	%mkrel %{?snap:0.%{rel}.%{snap}}%{!?snap:%{rel}}
URL:		https://userbase.kde.org/Apper
%if 0%{?snap:1}
Source0: 	apper-%{version}-%{snap}git.tar.xz
%else
Source0: 	http://download.kde.org/stable/apper/%{version}/src/%{name}-%{version}.tar.xz
%endif

# Upstream patches
# https://bugzilla.redhat.com/show_bug.cgi?id=1400011
# https://bugs.kde.org/show_bug.cgi?id=372292
Patch1:		0001-use-correct-QDialog-finished-signal-prototype.patch
# Have apper use proper icon for system software installers
Patch2:		0002-Set-better-icon-for-Apper.patch
# Fix apper progress bars for styles that render text next to progress bars rather than on them
# https://bugzilla.redhat.com/show_bug.cgi?id=1209017
Patch3:		0003-Do-not-call-base-class-rendering-of-column-when-rend.patch

# Patches from Fedora
## Hard-code known good style for apper (see rhbz#1209017)
#Patch100:	apper-0.9.3-style.patch

BuildRequires:	desktop-file-utils
BuildRequires:	chrpath
BuildRequires:	gettext
BuildRequires:	cmake(KDED)
BuildRequires:	cmake(KF5Config)
BuildRequires:	cmake(KF5DocTools)
BuildRequires:	cmake(KF5GuiAddons)
BuildRequires:	cmake(KF5I18n)
BuildRequires:	cmake(KF5KCMUtils)
BuildRequires:	cmake(KF5DBusAddons)
BuildRequires:	cmake(KF5KIO)
BuildRequires:	cmake(KF5Notifications)
BuildRequires:	cmake(KF5KDELibs4Support)
BuildRequires:	cmake(LibKWorkspace)
BuildRequires:	cmake(Qt5Quick)
BuildRequires:	cmake(Qt5Sql)
BuildRequires:	cmake(Qt5Widgets)
BuildRequires:	cmake(Qt5XmlPatterns)
BuildRequires:	extra-cmake-modules
BuildRequires:	kf5-macros

BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(packagekitqt5)

Requires:	packagekit

# (ngompa): Prefer usage of Oxygen style
#Recommends:	oxygen

# Software updater plasmoid for Plasma 5
Requires:	plasma-pk-updates

# Equivalent provider to gnome-software and other PK frontends
Provides:	packagekit-gui

%description
KDE interface for PackageKit.

%files
%doc TODO
%license COPYING
%{_kf5_bindir}/apper
%{_kf5_datadir}/apper/
%{_kf5_datadir}/applications/org.kde.apper.desktop
%{_kf5_datadir}/applications/org.kde.apper_installer.desktop
%{_kf5_datadir}/applications/org.kde.apper_settings.desktop
%{_kf5_datadir}/applications/org.kde.apper_updates.desktop
%{_kf5_libdir}/apper/
%{_qt5_importdir}/org/kde/apper/
%{_libexecdir}/apper-pk-session
%{_datadir}/dbus-1/services/kde-org.freedesktop.PackageKit.service
%{_qt5_plugindir}/kcm_apper.so
%{_kf5_datadir}/kservices5/kcm_apper.desktop
%{_qt5_plugindir}/kded_apperd.so
%{_kf5_datadir}/kservices5/kded/apperd.desktop
%{_kf5_datadir}/apperd/
%{_mandir}/man1/apper.1*
%{_datadir}/appdata/org.kde.apper.appdata.xml

#--------------------------------------------------------------------

%if %{with applet}
%package updater
Summary:	Plasma updater applet for Apper
Group:		System/Packaging
Requires:	%{name} = %{version}-%{release}

%description updater
This package provides the Plasma applet for Apper.

%files updater
%{_kf5_datadir}/kservices5/plasma-applet-org.packagekit.updater.desktop
%{_kf5_datadir}/plasma/plasmoids/org.packagekit.updater/
%endif
#--------------------------------------------------------------------

%prep
%setup -q
%autopatch -p1

# disable update applet by default
sed -i \
  -e 's|X-KDE-PluginInfo-EnabledByDefault=.*|X-KDE-PluginInfo-EnabledByDefault=false|g' \
    plasmoid/package/metadata.desktop

%build
# PackageKit-Dnf doesn't yet support autoremove from frontends
%cmake_kf5 -DAUTOREMOVE:BOOL=OFF
%make_build

%install
%make_install -C build

desktop-file-install \
		     --dir %{buildroot}%{_kf5_datadir}/applications \
		     --remove-mime-type='application/x-deb' \
		     %{buildroot}%{_kf5_datadir}/applications/*.desktop

# hack around rpath oddness
chrpath --list %{buildroot}%{_kf5_bindir}/apper
chrpath --replace %{_kf5_libdir}/apper %{buildroot}%{_kf5_bindir}/apper

# hack around gnome-packagekit conflict
# (cg) Note that this is a rubbish hack: While the files names may no longer
# conflict they are still trying to bus-activate the same service. This can
# never work properly when you have both installed anyway, so it's probably
# better to have the packages conflict IMO.
mv %{buildroot}%{_datadir}/dbus-1/services/org.freedesktop.PackageKit.service \
  %{buildroot}%{_datadir}/dbus-1/services/kde-org.freedesktop.PackageKit.service

%if ! %{with applet}
# Remove applet files
rm -fv %{buildroot}%{_kf5_datadir}/kservices5/plasma-applet-org.packagekit.updater.desktop
rm -rfv %{buildroot}%{_kf5_datadir}/plasma/plasmoids/org.packagekit.updater
%endif
